## shiboken 1.0.4

=== CMakeLists.txt ===
Include(icecc.cmake)
project(shiboken)

cmake_minimum_required(VERSION 2.6)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules/
                      ${CMAKE_MODULE_PATH})

find_package(Qt4 4.5.0)
find_package(ApiExtractor 0.10.4 REQUIRED)
find_package(GeneratorRunner 0.6.11 REQUIRED)
find_package(PythonLibs)
find_package(PythonInterpWithDebug)

add_definitions(${QT_DEFINITIONS})

set(shiboken_MAJOR_VERSION "1")
set(shiboken_MINOR_VERSION "0")
set(shiboken_MICRO_VERSION "4")
set(shiboken_VERSION "${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}.${shiboken_MICRO_VERSION}")

option(BUILD_TESTS "Build tests." TRUE)

if(MSVC)
    set(CMAKE_CXX_FLAGS "/Zc:wchar_t- /GR /EHsc /DWIN32 /D_WINDOWS /D_SCL_SECURE_NO_WARNINGS")
else()
    if(CMAKE_HOST_UNIX)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fvisibility=hidden -Wno-strict-aliasing")
    endif()
    set(CMAKE_CXX_FLAGS_DEBUG "-g")
    option(ENABLE_GCC_OPTIMIZATION "Enable specific GCC flags to optimization library size and performance. Only available on Release Mode" 0)
    if(ENABLE_GCC_OPTIMIZATION)
        set(CMAKE_BUILD_TYPE Release)
        set(CMAKE_CXX_FLAGS_RELEASE "-DNDEBUG -Os -Wl,-O1")
        if(NOT CMAKE_HOST_APPLE)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--hash-style=gnu")
        endif()
    endif()
endif()

set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )
set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE PATH "The subdirectory relative to the install prefix where libraries will be installed (default is /lib${LIB_SUFFIX})" FORCE)

if (WIN32)
    set(PATH_SEP "\;")
else()
    set(PATH_SEP ":")
endif()

# uninstall target
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
               IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}"
                  -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

set(SHIBOKEN_BUILD_TYPE "Release")
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    if(NOT PYTHON_DEBUG_LIBRARIES)
        message(FATAL_ERROR "Python debug library not found. Try compile shiboken with -DCMAKE_BUILD_TYPE=Release")
    endif()
    if(NOT PYTHON_WITH_DEBUG)
        message(WARNING "Compiling shiboken with debug enabled, but the python executable was not compiled with debug support.")
    else()
        add_definitions("-DPy_DEBUG")
        set(SBK_ADD_PY_DEBUG_DEFINITION "add_definitions(\"-DPy_DEBUG\")")
        set(SBK_PKG_CONFIG_PY_DEBUG_DEFINITION " -DPy_DEBUG")
    endif()
    set(SBK_PYTHON_LIBRARIES ${PYTHON_DEBUG_LIBRARIES})
    set(SHIBOKEN_BUILD_TYPE "Debug")
else()
    set(SBK_PYTHON_LIBRARIES ${PYTHON_LIBRARIES})
    add_definitions("-DNDEBUG")
endif()
if(APPLE)
    set(SBK_PYTHON_LIBRARIES "-undefined dynamic_lookup")
endif()

if(CMAKE_VERSION VERSION_LESS 2.8)
    set(SBK_PYTHON_INCLUDE_DIR ${PYTHON_INCLUDE_PATH})
else()
    set(SBK_PYTHON_INCLUDE_DIR ${PYTHON_INCLUDE_DIRS})
endif()

add_subdirectory(libshiboken)
add_subdirectory(doc)

# deps found, compile the generator.
if (QT4_FOUND AND ApiExtractor_FOUND AND GeneratorRunner_FOUND AND PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)
    add_subdirectory(generator)

    if (BUILD_TESTS)
        enable_testing()
        add_subdirectory(tests)
    endif()
else()
    message(WARNING "Some dependencies were not found, shiboken generator compilation disabled!")
endif()

add_subdirectory(data)

# dist target
set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${shiboken_VERSION})
add_custom_target(dist
    COMMAND mkdir -p "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}" &&
            git log > "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}/ChangeLog" &&
            git archive --prefix=${ARCHIVE_NAME}/ HEAD --format=tar --output="${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
            tar -C "${CMAKE_BINARY_DIR}" --owner=root --group=root -r "${ARCHIVE_NAME}/ChangeLog" -f "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
            bzip2 -f9 "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
            echo "Source package created at ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2.\n"
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== libshiboken/CMakeLists.txt ===
project(libshiboken)

option(ENABLE_VERSION_SUFFIX "Used to use current version in suffix to generated files. This is used to allow multiples versions installed simultaneous." FALSE)
if(ENABLE_VERSION_SUFFIX)
    set(shiboken_SUFFIX "-${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}")
else()
    set(shiboken_SUFFIX "")
endif()

#Find installed sparsehash
find_path(SPARSEHASH_INCLUDE_PATH sparseconfig.h PATH_SUFFIXES "/google/sparsehash")
if(SPARSEHASH_INCLUDE_PATH)
    message(STATUS "Using system hash found in: ${SPARSEHASH_INCLUDE_PATH}")
else()
    set(SPARSEHASH_INCLUDE_PATH ${CMAKE_SOURCE_DIR}/ext/sparsehash)
endif()

set(libshiboken_MAJOR_VERSION ${shiboken_MAJOR_VERSION})
set(libshiboken_MINOR_VERSION ${shiboken_MINOR_VERSION})
set(libshiboken_MICRO_VERSION ${shiboken_MICRO_VERSION})
set(libshiboken_VERSION "${libshiboken_MAJOR_VERSION}.${libshiboken_MINOR_VERSION}.${libshiboken_MICRO_VERSION}")
set(libshiboken_SOVERSION "${libshiboken_MAJOR_VERSION}.${libshiboken_MINOR_VERSION}")

set(libshiboken_SRC
basewrapper.cpp
gilstate.cpp
helper.cpp
sbkenum.cpp
bindingmanager.cpp
threadstatesaver.cpp
typeresolver.cpp
shibokenbuffer.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${SBK_PYTHON_INCLUDE_DIR}
                    ${SPARSEHASH_INCLUDE_PATH})
add_library(libshiboken SHARED ${libshiboken_SRC})
target_link_libraries(libshiboken ${SBK_PYTHON_LIBRARIES})
set_target_properties(libshiboken PROPERTIES OUTPUT_NAME "shiboken${shiboken_SUFFIX}-${PYTHON_BASENAME}"
                                             VERSION ${libshiboken_VERSION}
                                             SOVERSION ${libshiboken_SOVERSION}
                                             DEFINE_SYMBOL LIBSHIBOKEN_EXPORTS)

install(FILES
        autodecref.h
        basewrapper.h
        bindingmanager.h
        conversions.h
        gilstate.h
        helper.h
        sbkenum.h
        python25compat.h
        sbkdbg.h
        shiboken.h
        shibokenmacros.h
        threadstatesaver.h
        typeresolver.h
        shibokenbuffer.h
        DESTINATION include/shiboken${shiboken_SUFFIX})
install(TARGETS libshiboken EXPORT shiboken
                            LIBRARY DESTINATION "${LIB_INSTALL_DIR}"
                            ARCHIVE DESTINATION "${LIB_INSTALL_DIR}"
                            RUNTIME DESTINATION bin)

=== tests/libsample/CMakeLists.txt ===
project(libsample)

set(libsample_SRC
abstract.cpp
blackbox.cpp
bucket.cpp
collector.cpp
complex.cpp
derived.cpp
echo.cpp
functions.cpp
implicitconv.cpp
injectcode.cpp
listuser.cpp
modifications.cpp
mapuser.cpp
modified_constructor.cpp
multiple_derived.cpp
objectmodel.cpp
objecttype.cpp
objecttypelayout.cpp
objecttypeoperators.cpp
objectview.cpp
overload.cpp
overloadsort.cpp
pairuser.cpp
point.cpp
pointf.cpp
polygon.cpp
protected.cpp
reference.cpp
sample.cpp
samplenamespace.cpp
simplefile.cpp
size.cpp
sometime.cpp
str.cpp
strlist.cpp
virtualmethods.cpp
expression.cpp
filter.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions("-DLIBSAMPLE_BUILD")
add_library(libsample SHARED ${libsample_SRC})
set_property(TARGET libsample PROPERTY PREFIX "")

=== tests/samplebinding/CMakeLists.txt ===
project(sample)

set(sample_TYPESYSTEM
${CMAKE_CURRENT_SOURCE_DIR}/typesystem_sample.xml
)

set(sample_SRC
${CMAKE_CURRENT_BINARY_DIR}/sample/abstractmodifications_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/abstract_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base1_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base2_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base3_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base4_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base5_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base6_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/blackbox_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/bucket_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/collector_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/color_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/ctorconvrule_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sbkdate_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/derived_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/derived_someinnerclass_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/echo_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/event_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/expression_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/handleholder_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/implicitconv_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/implicitbase_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/implicittarget_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/intlist_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sortedoverload_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/intwrapper_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/injectcode_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/listuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mapuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived1_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived2_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived3_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived4_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived5_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/modelindex_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/modifications_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/modifiedconstructor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/noimplicitconversion_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/nondefaultctor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objectmodel_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objecttype_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objecttypelayout_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objecttypeoperators_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objectview_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objtypereference_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/oddbooluser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/overload_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/overload2_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/pairuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/pen_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/persistentmodelindex_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/point_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/pointf_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/pointerholder_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/polygon_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/privatector_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/privatedtor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedenumclass_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectednonpolymorphic_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphic_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphicdaughter_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphicgranddaughter_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedproperty_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedvirtualdestructor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/rect_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/rectf_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/reference_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/referentmodelindex_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sample_module_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sample_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sample_sample_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_someclass_someinnerclass_okthisisrecursiveenough_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_someclass_someinnerclass_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_someclass_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_derivedfromnamespace_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/simplefile_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/size_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sonofmderived1_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/str_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/strlist_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/time_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/unremovednamespace_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/virtualdaughter_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/virtualdtor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/virtualmethods_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/voidholder_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/valueandvirtual_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/filter_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/data_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/intersection_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/union_wrapper.cpp
)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/sample-binding.txt.in"
               "${CMAKE_CURRENT_BINARY_DIR}/sample-binding.txt" @ONLY)

add_custom_command(OUTPUT ${sample_SRC}
COMMAND ${GENERATORRUNNER_BINARY} --project-file=${CMAKE_CURRENT_BINARY_DIR}/sample-binding.txt ${GENERATOR_EXTRA_FLAGS}
WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
COMMENT "Running generator for 'sample' test binding..."
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}
                    ${SBK_PYTHON_INCLUDE_DIR}
                    ${libsample_SOURCE_DIR}
                    ${libshiboken_SOURCE_DIR})
add_library(sample MODULE ${sample_SRC})
set_property(TARGET sample PROPERTY PREFIX "")
if(WIN32)
    set_property(TARGET sample PROPERTY SUFFIX ".pyd")
endif()
target_link_libraries(sample
                      libsample
                      ${SBK_PYTHON_LIBRARIES}
                      libshiboken)

add_dependencies(sample shiboken_generator)

=== debian/changelog ===
shiboken (1.0.4-2) unstable; urgency=low

  * Update symbols:
    - cope with size_t size differences between 32-64 bit machines.
    - sparc-specific updates.

 -- Didier Raboud <odyx@debian.org>  Fri, 24 Jun 2011 13:54:05 +0200

shiboken (1.0.4-1) unstable; urgency=low

  * New 1.0.4 upstream "The winter is coming" release
    - Bump B-Ds:
      - on generatorrunner to 0.6.11.
      - on apiextractor to 0.10.4.
  * Add 13 symbols for 1.0.4.

 -- Didier Raboud <odyx@debian.org>  Thu, 23 Jun 2011 16:56:20 +0200

=== debian/control ===
Source: shiboken
Section: devel
Priority: optional
Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Uploaders: Didier Raboud <odyx@debian.org>
Build-Depends: dpkg-dev (>= 1.15.7), debhelper (>= 7.3.12), cmake (>= 2.8.2),
 libqt4-dev (>= 4:4.7.0),
 libapiextractor-dev (>= 0.10.4),
 generatorrunner (>= 0.6.11), libgenrunner-dev (>= 0.6.11),
 libsparsehash-dev (>= 1.6-1.1~),
 python-all-dev (>= 2.6.6-3), python-all-dbg (>= 2.6.6-3)
Build-Depends-Indep: python-sphinx
X-Python-Version: >= 2.6
Standards-Version: 3.9.2.0
Vcs-Svn: svn://svn.debian.org/python-modules/packages/shiboken/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/python-modules/packages/shiboken/?op=log
Homepage: http://www.pyside.org/

Package: shiboken
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, generatorrunner (>= 0.6.11)
Description: CPython bindings generator for C++ libraries
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 Shiboken is the binding generator used to create the PySide bindings.

Package: shiboken-doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery
Section: doc
Description: CPython bindings generator for C++ libraries documentation
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 Shiboken is the binding generator used to create the PySide bindings; this
 package contains its documentation.

Package: libshiboken1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CPython bindings generator for C++ libraries - shared library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This is the shared library used by shiboken.

Package: libshiboken-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libshiboken1.0 (= ${binary:Version})
Description: development files for the shiboken bindings generator library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This package contains the development files for the library.

Package: shiboken-dbg
Section: debug
Architecture: any
Priority: extra
Depends: ${shlibs:Depends}, ${misc:Depends},
         libshiboken1.0 (= ${binary:Version}),
         shiboken (= ${binary:Version})
Description: debugging symbols for shiboken and its library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This package contains the debugging symbols for shiboken and libshiboken.

## shiboken 1.0.5-1maemo1

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
                       ${CMAKE_MODULE_PATH})
 
 find_package(Qt4 4.5.0)
-find_package(ApiExtractor 0.10.4 REQUIRED)
+find_package(ApiExtractor 0.10.5 REQUIRED)
 find_package(GeneratorRunner 0.6.11 REQUIRED)
 find_package(PythonLibs)
 find_package(PythonInterpWithDebug)
@@ -16,7 +16,7 @@
 
 set(shiboken_MAJOR_VERSION "1")
 set(shiboken_MINOR_VERSION "0")
-set(shiboken_MICRO_VERSION "4")
+set(shiboken_MICRO_VERSION "5")
 set(shiboken_VERSION "${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}.${shiboken_MICRO_VERSION}")
 
 option(BUILD_TESTS "Build tests." TRUE)

=== tests/CMakeLists.txt ===
add_subdirectory(libminimal)
if(NOT DEFINED MINIMAL_TESTS)
    add_subdirectory(libsample)
    add_subdirectory(libother)
endif()

if(WIN32 OR DEFINED AVOID_PROTECTED_HACK)
    message(STATUS "Tests will be generated avoiding the protected hack!")
    set(GENERATOR_EXTRA_FLAGS --avoid-protected-hack)
else()
    message(STATUS "Tests will be generated using the protected hack!")
    set(GENERATOR_EXTRA_FLAGS )
endif()

add_subdirectory(minimalbinding)
if(NOT DEFINED MINIMAL_TESTS)
    add_subdirectory(samplebinding)
    add_subdirectory(otherbinding)
endif()

if(DEFINED MINIMAL_TESTS)
    file(GLOB TEST_FILES minimalbinding/*_test.py)
else()
    file(GLOB TEST_FILES minimalbinding/*_test.py
                         samplebinding/*_test.py
                         otherbinding/*_test.py)
endif()

set(test_blacklist "")

find_package(PythonInterp REQUIRED)
if(NOT CTEST_TESTING_TIMEOUT)
    set(CTEST_TESTING_TIMEOUT 60)
endif()

if(CMAKE_VERSION VERSION_LESS 2.8)
    message("CMake version greater than 2.8 necessary to run tests")
else()
    if(WIN32)
        set(TEST_PYTHONPATH     "${minimal_BINARY_DIR};${sample_BINARY_DIR};${other_BINARY_DIR}")
        set(TEST_LIBRARY_PATH   "$ENV{PATH};${libminimal_BINARY_DIR};${libsample_BINARY_DIR};${libother_BINARY_DIR};${libshiboken_BINARY_DIR}")
        set(LIBRARY_PATH_VAR    "PATH")
        string(REPLACE "\\" "/" TEST_PYTHONPATH "${TEST_PYTHONPATH}")
        string(REPLACE "\\" "/" TEST_LIBRARY_PATH "${TEST_LIBRARY_PATH}")
        string(REPLACE ";" "\\;" TEST_PYTHONPATH "${TEST_PYTHONPATH}")
        string(REPLACE ";" "\\;" TEST_LIBRARY_PATH "${TEST_LIBRARY_PATH}")
    else()
        set(TEST_PYTHONPATH     "${minimal_BINARY_DIR}:${sample_BINARY_DIR}:${other_BINARY_DIR}")
        set(TEST_LIBRARY_PATH   "$ENV{LD_LIBRARY_PATH}:${libminimal_BINARY_DIR}:${libsample_BINARY_DIR}:${libother_BINARY_DIR}:${libshiboken_BINARY_DIR}")
        set(LIBRARY_PATH_VAR    "LD_LIBRARY_PATH")
    endif()

    foreach(test_file ${TEST_FILES})
        string(REGEX MATCH "/([^/]+)_test.py" test_name ${test_file})
        list(FIND test_blacklist ${CMAKE_MATCH_1} expect_fail)
        add_test(${CMAKE_MATCH_1} ${PYTHON_EXECUTABLE} ${test_file})
        set_tests_properties(${CMAKE_MATCH_1} PROPERTIES ENVIRONMENT "PYTHONPATH=${TEST_PYTHONPATH};${LIBRARY_PATH_VAR}=${TEST_LIBRARY_PATH}")
        set_tests_properties(${CMAKE_MATCH_1} PROPERTIES TIMEOUT ${CTEST_TESTING_TIMEOUT})
        if (${expect_fail} GREATER -1)
            set_tests_properties(${CMAKE_MATCH_1} PROPERTIES WILL_FAIL TRUE)
        endif()
    endforeach()
endif()

=== debian/changelog ===
shiboken (1.0.5-1maemo1) unstable; urgency=low

  * New version from upstream: 1.0.5

 -- Willer Moreira <willer.moreira@indt.org.br>  Tue, 26 Jul 2011 08:53:32 -0400

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,13 @@
 Source: shiboken
 Section: devel
-Priority: optional
-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
-Uploaders: Didier Raboud <odyx@debian.org>
-Build-Depends: dpkg-dev (>= 1.15.7), debhelper (>= 7.3.12), cmake (>= 2.8.2),
- libqt4-dev (>= 4:4.7.0),
- libapiextractor-dev (>= 0.10.4),
- generatorrunner (>= 0.6.11), libgenrunner-dev (>= 0.6.11),
- libsparsehash-dev (>= 1.6-1.1~),
- python-all-dev (>= 2.6.6-3), python-all-dbg (>= 2.6.6-3)
-Build-Depends-Indep: python-sphinx
-X-Python-Version: >= 2.6
-Standards-Version: 3.9.2.0
+Priority: extra
+Maintainer: PyMaemo Team <pymaemo-developers@garage.maemo.org>
+XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
+Build-Depends: dpkg-dev (>= 1.14.25), debhelper7 (>= 7.3.12), cmake (>= 2.6.0),
+	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.10.5), generatorrunner (>= 0.6.11), libgenrunner-dev (>= 0.6.11),
+	python-all-dev, python-all-dbg, quilt
+XS-Python-Version: >= 2.5
+Standards-Version: 3.8.4
 Vcs-Svn: svn://svn.debian.org/python-modules/packages/shiboken/trunk/
 Vcs-Browser: http://svn.debian.org/wsvn/python-modules/packages/shiboken/?op=log
 Homepage: http://www.pyside.org/
@@ -27,22 +23,11 @@
  .
  Shiboken is the binding generator used to create the PySide bindings.
 
-Package: shiboken-doc
-Architecture: all
-Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery
-Section: doc
-Description: CPython bindings generator for C++ libraries documentation
- Shiboken is a bindings generator for C++ libraries that outputs CPython
- source code. It uses generatorrunner and apiextractor to collect information
- from library headers, merging modifications and handwritten code defined in the
- typesystem description.
- .
- Shiboken is the binding generator used to create the PySide bindings; this
- package contains its documentation.
-
 Package: libshiboken1.0
 Section: libs
 Architecture: any
+Conflicts: libshiboken0 (<< 1.0)
+Replaces: libshiboken0 (<< 1.0)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: CPython bindings generator for C++ libraries - shared library
  Shiboken is a bindings generator for C++ libraries that outputs CPython
@@ -77,4 +62,4 @@
  from library headers, merging modifications and handwritten code defined in the
  typesystem description.
  .
- This package contains the debugging symbols for shiboken and libshiboken.
+ This package contains the debugging symbols for shiboken and libshiboken0.

## shiboken 1.0.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,8 +7,8 @@
                       ${CMAKE_MODULE_PATH})
 
 find_package(Qt4 4.5.0)
-find_package(ApiExtractor 0.10.5 REQUIRED)
-find_package(GeneratorRunner 0.6.11 REQUIRED)
+find_package(ApiExtractor 0.10.6 REQUIRED)
+find_package(GeneratorRunner 0.6.12 REQUIRED)
 find_package(PythonLibs)
 find_package(PythonInterpWithDebug)
 
@@ -16,7 +16,7 @@
 
 set(shiboken_MAJOR_VERSION "1")
 set(shiboken_MINOR_VERSION "0")
-set(shiboken_MICRO_VERSION "5")
+set(shiboken_MICRO_VERSION "6")
 set(shiboken_VERSION "${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}.${shiboken_MICRO_VERSION}")
 
 option(BUILD_TESTS "Build tests." TRUE)

=== libshiboken/CMakeLists.txt ===
--- 
+++ 
@@ -26,6 +26,7 @@
 gilstate.cpp
 helper.cpp
 sbkenum.cpp
+sbkmodule.cpp
 bindingmanager.cpp
 threadstatesaver.cpp
 typeresolver.cpp
@@ -50,6 +51,7 @@
         gilstate.h
         helper.h
         sbkenum.h
+        sbkmodule.h
         python25compat.h
         sbkdbg.h
         shiboken.h

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,7 @@
                          samplebinding/*_test.py
                          otherbinding/*_test.py)
 endif()
+list(SORT TEST_FILES)
 
 set(test_blacklist "")
 
@@ -51,13 +52,14 @@
     endif()
 
     foreach(test_file ${TEST_FILES})
-        string(REGEX MATCH "/([^/]+)_test.py" test_name ${test_file})
-        list(FIND test_blacklist ${CMAKE_MATCH_1} expect_fail)
-        add_test(${CMAKE_MATCH_1} ${PYTHON_EXECUTABLE} ${test_file})
-        set_tests_properties(${CMAKE_MATCH_1} PROPERTIES ENVIRONMENT "PYTHONPATH=${TEST_PYTHONPATH};${LIBRARY_PATH_VAR}=${TEST_LIBRARY_PATH}")
-        set_tests_properties(${CMAKE_MATCH_1} PROPERTIES TIMEOUT ${CTEST_TESTING_TIMEOUT})
+        string(REGEX MATCH "/([^/]+)binding/([^/]+)_test.py" tmp ${test_file})
+        set(test_name "${CMAKE_MATCH_1}_${CMAKE_MATCH_2}")
+        list(FIND test_blacklist ${test_name} expect_fail)
+        add_test(${test_name} ${PYTHON_EXECUTABLE} ${test_file})
+        set_tests_properties(${test_name} PROPERTIES ENVIRONMENT "PYTHONPATH=${TEST_PYTHONPATH};${LIBRARY_PATH_VAR}=${TEST_LIBRARY_PATH}")
+        set_tests_properties(${test_name} PROPERTIES TIMEOUT ${CTEST_TESTING_TIMEOUT})
         if (${expect_fail} GREATER -1)
-            set_tests_properties(${CMAKE_MATCH_1} PROPERTIES WILL_FAIL TRUE)
+            set_tests_properties(${test_name} PROPERTIES WILL_FAIL TRUE)
         endif()
     endforeach()
 endif()

=== tests/libminimal/CMakeLists.txt ===
project(libminimal)

set(libminimal_SRC
obj.cpp
listuser.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions("-DLIBMINIMAL_BUILD")
add_library(libminimal SHARED ${libminimal_SRC})
set_property(TARGET libminimal PROPERTY PREFIX "")

=== tests/samplebinding/CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,7 @@
 ${CMAKE_CURRENT_BINARY_DIR}/sample/base5_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/base6_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/blackbox_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/bytearray_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/bucket_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/collector_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/color_wrapper.cpp
@@ -24,6 +25,7 @@
 ${CMAKE_CURRENT_BINARY_DIR}/sample/echo_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/event_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/expression_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/friendofonlycopy_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/handleholder_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/implicitconv_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/implicitbase_wrapper.cpp
@@ -46,16 +48,21 @@
 ${CMAKE_CURRENT_BINARY_DIR}/sample/nondefaultctor_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/objectmodel_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/objecttype_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/objecttypeholder_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/objecttypelayout_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/objecttypeoperators_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/objectview_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/objtypereference_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/oddbooluser_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/onlycopy_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/overload_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/overload2_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/pairuser_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/pen_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/persistentmodelindex_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/photon_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/photon_valueidentity_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/photon_valueduplicator_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/point_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/pointf_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/pointerholder_wrapper.cpp
@@ -83,6 +90,7 @@
 ${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_derivedfromnamespace_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/simplefile_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/size_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/sizef_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/sonofmderived1_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/str_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/strlist_wrapper.cpp

=== debian/changelog ===
shiboken (1.0.6-1ubuntu1) oneiric; urgency=low

  * debian/control: Ubuntu 11.10 only has debhelper 8.9.0.

 -- Barry Warsaw <barry@ubuntu.com>  Tue, 06 Sep 2011 15:15:30 -0400

shiboken (1.0.6-1) unstable; urgency=low

  * New 1.0.6 upstream release.
    - Fixes the documentation generation.
    - Bump B-Ds:
      - on generatorrunner to 0.6.12;
      - on apiextractor to 0.10.6.

  * Add 9 new symbols for 1.0.6.

  * Don't dh_auto_install in -indep as it's not needed.
  * Use dh_sphinxdoc to handle the generated documentation.
    - Replace libjs-jquery by ${sphinxdoc:Depends} in Depends.
    - Drop shiboken-doc.links including explicit symlink to
      libjs-jquery.
    - Conditionally use dh_sphinxdoc when needed.
  * Multiarch-update the shiboken generatorrunner plugin path.
    - Bump B-D on generatorrunner to a multiarch'ed version.
  * Convert library to multiarch.
    - Bump B-D:
      - on debhelper to 8.9.3.
      - on cmake to 2.8.4+dfsg.1-3~.
    - Bump debhelper compatibility level to 9.
    - Override lintian warning about debhelper being too young.
    - Update *.install files to cope with new library paths.
    - Update .so symlinks paths.
    - Initialize D_H_MULTIARCH from dpkg-architectures, use it in the
      LIB_SUFFIX cmake variable
    - Add a Pre-Depends on multiarch-support to the libshiboken package.
    - Add Multi-Arch: same to the libshiboken package.

 -- Didier Raboud <odyx@debian.org>  Tue, 23 Aug 2011 14:59:16 +0200

shiboken (1.0.5-2) unstable; urgency=low

  * Update buildsystem (again) to cleanly separate arch-{all,indep}.
    - Bump compat and B-D on debhelper to 8.
    - Update rules to build documentation at the right moment.
  * Drop three noisy sparc symbols.

 -- Didier Raboud <odyx@debian.org>  Tue, 02 Aug 2011 17:23:03 +0200

shiboken (1.0.5-1) unstable; urgency=low

  * New 1.0.5 upstream "And no name was given that day" release
    - Bump B-Ds:
      - on apiextractor to 0.10.5.
    - Add 3 symbols to libshiboken1.0 symbol file.

 -- Didier Raboud <odyx@debian.org>  Fri, 22 Jul 2011 23:50:11 +0200

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,25 @@
 Source: shiboken
 Section: devel
-Priority: extra
-Maintainer: PyMaemo Team <pymaemo-developers@garage.maemo.org>
+Priority: optional
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
-Build-Depends: dpkg-dev (>= 1.14.25), debhelper7 (>= 7.3.12), cmake (>= 2.6.0),
-	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.10.5), generatorrunner (>= 0.6.11), libgenrunner-dev (>= 0.6.11),
-	python-all-dev, python-all-dbg, quilt
-XS-Python-Version: >= 2.5
-Standards-Version: 3.8.4
+Uploaders: Didier Raboud <odyx@debian.org>
+Build-Depends: dpkg-dev (>= 1.15.7), debhelper (>= 8.9.0), cmake (>= 2.8.4+dfsg.1-3~),
+ libqt4-dev (>= 4:4.7.0),
+ libapiextractor-dev (>= 0.10.6),
+ generatorrunner (>= 0.6.12), libgenrunner-dev (>= 0.6.12),
+ libsparsehash-dev (>= 1.6-1.1~),
+ python-all-dev (>= 2.6.6-3), python-all-dbg (>= 2.6.6-3)
+Build-Depends-Indep: python-sphinx
+X-Python-Version: >= 2.6
+Standards-Version: 3.9.2.0
 Vcs-Svn: svn://svn.debian.org/python-modules/packages/shiboken/trunk/
 Vcs-Browser: http://svn.debian.org/wsvn/python-modules/packages/shiboken/?op=log
 Homepage: http://www.pyside.org/
 
 Package: shiboken
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, generatorrunner (>= 0.6.11)
+Depends: ${shlibs:Depends}, ${misc:Depends}, generatorrunner (>= 0.6.12)
 Description: CPython bindings generator for C++ libraries
  Shiboken is a bindings generator for C++ libraries that outputs CPython
  source code. It uses generatorrunner and apiextractor to collect information
@@ -23,12 +28,25 @@
  .
  Shiboken is the binding generator used to create the PySide bindings.
 
+Package: shiboken-doc
+Architecture: all
+Depends: ${misc:Depends}, ${sphinxdoc:Depends}
+Section: doc
+Description: CPython bindings generator for C++ libraries documentation
+ Shiboken is a bindings generator for C++ libraries that outputs CPython
+ source code. It uses generatorrunner and apiextractor to collect information
+ from library headers, merging modifications and handwritten code defined in the
+ typesystem description.
+ .
+ Shiboken is the binding generator used to create the PySide bindings; this
+ package contains its documentation.
+
 Package: libshiboken1.0
 Section: libs
 Architecture: any
-Conflicts: libshiboken0 (<< 1.0)
-Replaces: libshiboken0 (<< 1.0)
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: same
 Description: CPython bindings generator for C++ libraries - shared library
  Shiboken is a bindings generator for C++ libraries that outputs CPython
  source code. It uses generatorrunner and apiextractor to collect information
@@ -62,4 +80,4 @@
  from library headers, merging modifications and handwritten code defined in the
  typesystem description.
  .
- This package contains the debugging symbols for shiboken and libshiboken0.
+ This package contains the debugging symbols for shiboken and libshiboken.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2 --buildsystem=cmake --parallel

# Python versions (default is first)
PYVERSIONS=$(shell pyversions -v -r)
DEFAULT_PY=$(shell pyversions -v -d)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# G++ versions
g++-version := $(shell readlink /usr/bin/g++ | sed -e 's/g++-\(.*\)\.\(.*\)/\1\2/')
g++-version-ge-4.5 := $(shell if test $(g++-version) -ge 45; then echo "yes"; else echo "no"; fi)

#### CONFIGURE ####

override_dh_auto_configure: $(PYVERSIONS:%=override_dh_auto_configure_dbg-%) $(PYVERSIONS:%=override_dh_auto_configure-%)

override_dh_auto_configure_dbg-%:
	mkdir -p build-$*-dbg
	dh_auto_configure -a --builddirectory=build-$*-dbg -- \
	-DCMAKE_BUILD_TYPE:STRING="Debug" \
	-DCMAKE_SKIP_RPATH=true \
	-DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
	-DCMAKE_USE_PYTHON_VERSION="$*-dbg;$*_d;$*" \
	-DPython_ADDITIONAL_VERSIONS="$*-dbg;$*_d;$*"

override_dh_auto_configure-%:
	mkdir -p build-$*
	dh_auto_configure --builddirectory=build-$* -- \
	-DCMAKE_BUILD_TYPE:STRING="Release" \
	-DCMAKE_SKIP_RPATH=true \
	-DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
	-DCMAKE_USE_PYTHON_VERSION=$* \
	-DPython_ADDITIONAL_VERSIONS=$* \
	-DDEFAULT_PYTHON_BASENAME=python${DEFAULT_PY}

#### BUILD ####

override_dh_auto_build: $(PYVERSIONS:%=override_dh_auto_build_dbg-%) $(PYVERSIONS:%=override_dh_auto_build-%)
	dh_auto_build -i --builddirectory=build-$(DEFAULT_PY) -- doc

override_dh_auto_build_dbg-%:
	dh_auto_build -a --builddirectory=build-$*-dbg

override_dh_auto_build-%:
	dh_auto_build -a --builddirectory=build-$*

#### INSTALL ####

override_dh_auto_install: $(PYVERSIONS:%=override_dh_auto_install_dbg-%) $(PYVERSIONS:%=override_dh_auto_install-%)

override_dh_auto_install_dbg-%:
	dh_auto_install -a --builddirectory=build-$*-dbg --destdir=debian/tmp-dbg

override_dh_auto_install-%:
	dh_auto_install -a --builddirectory=build-$*

#### STRIP ####
override_dh_strip:
	dh_strip -a --dbg-package=shiboken-dbg --exclude=-dbg.so

#### TEST ####

override_dh_auto_test: $(PYVERSIONS:%=override_dh_auto_test_dbg-%) $(PYVERSIONS:%=override_dh_auto_test-%)

override_dh_auto_test_dbg-%:
	- dh_auto_test -a --builddirectory=build-$*-dbg

override_dh_auto_test-%:
	dh_auto_test -a --builddirectory=build-$*

#### CLEAN ####
override_dh_auto_clean:
	rm -rf build-*
	rm -rf debian/tmp-dbg
	rm -f debian/libshiboken1.0.symbols
	rm -f debian/libshiboken1.0.symbols-py*

#### DEBIAN INSTALL ####

override_dh_install: override_dh_install_done
	dh_install -i

override_dh_install_real:
	# Install the debug variant
	dh_install --sourcedir=debian/tmp-dbg -pshiboken-dbg
	
	# Install the other variants
	dh_install -a --list-missing --remaining-packages

override_dh_install_done: override_dh_install_real
ifneq (,$(filter libshiboken-dev, $(shell dh_listpackages)))
	# Setup the default version symbolic links
	ln -sf libshiboken-python${DEFAULT_PY}.so \
	               debian/libshiboken-dev/usr/lib/$(DEB_HOST_MULTIARCH)/libshiboken.so
endif
ifneq (,$(filter shiboken-dbg, $(shell dh_listpackages)))
	ln -sf libshiboken-python${DEFAULT_PY}-dbg.so \
	               debian/shiboken-dbg/usr/lib/$(DEB_HOST_MULTIARCH)/libshiboken-dbg.so
endif

#### Shared libs ####
override_dh_makeshlibs: $(PYVERSIONS:%=override_dh_makeshlibs-%)
	cat debian/libshiboken1.0.symbols-py* > debian/libshiboken1.0.symbols
	# Package shiboken ships a usr/lib/generatorrunner/*.so plugin. No shared libs in there.
	dh_makeshlibs -a -Nshiboken

override_dh_makeshlibs-%:
	echo "libshiboken-python$*.so.1.0 libshiboken1.0 #MINVER#" > debian/libshiboken1.0.symbols-py$*
	cat debian/libshiboken1.0.symbols.pristine >> debian/libshiboken1.0.symbols-py$*
ifeq ($(g++-version-ge-4.5),yes)
	# g++ version is >= 4.5, add related symbols
	sed -e 's|^ _| (ge-g++4.5)_|g' debian/libshiboken1.0.symbols.g++-ge-4.5 >> debian/libshiboken1.0.symbols-py$*
else
	# g++ version is < 4.5, add related symbols
	sed -e 's|^ _| (lt-g++4.5)_|g' debian/libshiboken1.0.symbols.g++-lt-4.5 >> debian/libshiboken1.0.symbols-py$*
endif

override_dh_installdocs:
	dh_installdocs
ifneq (,$(filter shiboken-doc, $(shell dh_listpackages)))
	dh_sphinxdoc -pshiboken-doc
endif

## shiboken 1.0.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,19 +7,34 @@
                       ${CMAKE_MODULE_PATH})
 
 find_package(Qt4 4.5.0)
-find_package(ApiExtractor 0.10.6 REQUIRED)
-find_package(GeneratorRunner 0.6.12 REQUIRED)
-find_package(PythonLibs)
-find_package(PythonInterpWithDebug)
+find_package(ApiExtractor 0.10.8 REQUIRED)
+find_package(GeneratorRunner 0.6.14 REQUIRED)
 
 add_definitions(${QT_DEFINITIONS})
 
 set(shiboken_MAJOR_VERSION "1")
 set(shiboken_MINOR_VERSION "0")
-set(shiboken_MICRO_VERSION "6")
+set(shiboken_MICRO_VERSION "9")
 set(shiboken_VERSION "${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}.${shiboken_MICRO_VERSION}")
 
 option(BUILD_TESTS "Build tests." TRUE)
+option(USE_PYTHON3 "Use python3 libraries to build shiboken." FALSE)
+
+if (USE_PYTHON3)
+    find_package(Python3Libs)
+    find_package(Python3InterpWithDebug)
+    #use commom vars
+    set(PYTHONLIBS_FOUND ${PYTHON3LIBS_FOUND})
+    set(PYTHON_LIBRARIES ${PYTHON3_LIBRARIES})
+    set(PYTHON_INCLUDE_DIRS ${PYTHON3_INCLUDE_DIRS})
+    set(PYTHON_DEBUG_LIBRARIES ${PYTHON3_DEBUG_LIBRARIES})
+    set(PYTHONINTERP_FOUND ${PYTHON3INTERP_FOUND})
+    set(PYTHON_EXECUTABLE ${PYTHON3_EXECUTABLE})
+else()
+    find_package(PythonLibs 2.6)
+    find_package(PythonInterpWithDebug)
+endif()
+
 
 if(MSVC)
     set(CMAKE_CXX_FLAGS "/Zc:wchar_t- /GR /EHsc /DWIN32 /D_WINDOWS /D_SCL_SECURE_NO_WARNINGS")

=== libshiboken/CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,7 @@
 helper.cpp
 sbkenum.cpp
 sbkmodule.cpp
+sbkstring.cpp
 bindingmanager.cpp
 threadstatesaver.cpp
 typeresolver.cpp
@@ -38,7 +39,7 @@
                     ${SPARSEHASH_INCLUDE_PATH})
 add_library(libshiboken SHARED ${libshiboken_SRC})
 target_link_libraries(libshiboken ${SBK_PYTHON_LIBRARIES})
-set_target_properties(libshiboken PROPERTIES OUTPUT_NAME "shiboken${shiboken_SUFFIX}-${PYTHON_BASENAME}"
+set_target_properties(libshiboken PROPERTIES OUTPUT_NAME "shiboken${shiboken_SUFFIX}${PYTHON_SUFFIX}"
                                              VERSION ${libshiboken_VERSION}
                                              SOVERSION ${libshiboken_SOVERSION}
                                              DEFINE_SYMBOL LIBSHIBOKEN_EXPORTS)
@@ -54,11 +55,13 @@
         sbkmodule.h
         python25compat.h
         sbkdbg.h
+        sbkstring.h
         shiboken.h
         shibokenmacros.h
         threadstatesaver.h
         typeresolver.h
         shibokenbuffer.h
+        sbkpython.h
         DESTINATION include/shiboken${shiboken_SUFFIX})
 install(TARGETS libshiboken EXPORT shiboken
                             LIBRARY DESTINATION "${LIB_INSTALL_DIR}"

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -38,7 +38,7 @@
     message("CMake version greater than 2.8 necessary to run tests")
 else()
     if(WIN32)
-        set(TEST_PYTHONPATH     "${minimal_BINARY_DIR};${sample_BINARY_DIR};${other_BINARY_DIR}")
+        set(TEST_PYTHONPATH     "${minimal_BINARY_DIR};${sample_BINARY_DIR};${other_BINARY_DIR};${CMAKE_CURRENT_SOURCE_DIR}")
         set(TEST_LIBRARY_PATH   "$ENV{PATH};${libminimal_BINARY_DIR};${libsample_BINARY_DIR};${libother_BINARY_DIR};${libshiboken_BINARY_DIR}")
         set(LIBRARY_PATH_VAR    "PATH")
         string(REPLACE "\\" "/" TEST_PYTHONPATH "${TEST_PYTHONPATH}")
@@ -46,7 +46,7 @@
         string(REPLACE ";" "\\;" TEST_PYTHONPATH "${TEST_PYTHONPATH}")
         string(REPLACE ";" "\\;" TEST_LIBRARY_PATH "${TEST_LIBRARY_PATH}")
     else()
-        set(TEST_PYTHONPATH     "${minimal_BINARY_DIR}:${sample_BINARY_DIR}:${other_BINARY_DIR}")
+        set(TEST_PYTHONPATH     "${minimal_BINARY_DIR}:${sample_BINARY_DIR}:${other_BINARY_DIR}:${CMAKE_CURRENT_SOURCE_DIR}")
         set(TEST_LIBRARY_PATH   "$ENV{LD_LIBRARY_PATH}:${libminimal_BINARY_DIR}:${libsample_BINARY_DIR}:${libother_BINARY_DIR}:${libshiboken_BINARY_DIR}")
         set(LIBRARY_PATH_VAR    "LD_LIBRARY_PATH")
     endif()

=== debian/changelog ===
shiboken (1.0.9-3) unstable; urgency=low

  * Brown-paper bag: Fix symbols typo from previous upload.

 -- Didier Raboud <odyx@debian.org>  Wed, 26 Oct 2011 15:21:55 +0200

shiboken (1.0.9-2) unstable; urgency=low

  * Update symbols to cope with size_t size differences between 32-64
    bit machines.

 -- Didier Raboud <odyx@debian.org>  Wed, 26 Oct 2011 12:27:24 +0200

shiboken (1.0.9-1) unstable; urgency=low

  * New 1.0.9 upstream release.
  * Bump B-Ds:
    - on generatorrunner to 0.6.14;
    - on apiextractor to 0.10.8.

  * Add 12 new symbols for 1.0.9.
  * Update packaging to 1.0.9:
    - Refresh patches, add pythonversionindep.patch to allow picking a
      specific python version.
    - Make sure the picked pkg-config file is the default one.
    - Update the cmake configuration calls.

 -- Didier Raboud <odyx@debian.org>  Wed, 26 Oct 2011 10:56:09 +0200

shiboken (1.0.7-1) unstable; urgency=low

  * New 1.0.7 upstream release.
  * Bump B-Ds:
    - on generatorrunner to 0.6.13;
    - on apiextractor to 0.10.7.

  * Add two 1.0.7 symbols.
  * Update lintian overrides for the -dbg package.

 -- Didier Raboud <odyx@debian.org>  Thu, 22 Sep 2011 14:13:20 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: shiboken
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
+Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
 Uploaders: Didier Raboud <odyx@debian.org>
-Build-Depends: dpkg-dev (>= 1.15.7), debhelper (>= 8.9.0), cmake (>= 2.8.4+dfsg.1-3~),
+Build-Depends: dpkg-dev (>= 1.15.7), debhelper (>= 8.9.3~), cmake (>= 2.8.4+dfsg.1-3~),
  libqt4-dev (>= 4:4.7.0),
- libapiextractor-dev (>= 0.10.6),
- generatorrunner (>= 0.6.12), libgenrunner-dev (>= 0.6.12),
+ libapiextractor-dev (>= 0.10.8),
+ generatorrunner (>= 0.6.14), libgenrunner-dev (>= 0.6.14),
  libsparsehash-dev (>= 1.6-1.1~),
  python-all-dev (>= 2.6.6-3), python-all-dbg (>= 2.6.6-3)
 Build-Depends-Indep: python-sphinx
@@ -19,7 +18,7 @@
 
 Package: shiboken
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, generatorrunner (>= 0.6.12)
+Depends: ${shlibs:Depends}, ${misc:Depends}, generatorrunner (>= 0.6.14)
 Description: CPython bindings generator for C++ libraries
  Shiboken is a bindings generator for C++ libraries that outputs CPython
  source code. It uses generatorrunner and apiextractor to collect information

=== debian/rules ===
--- 
+++ 
@@ -23,8 +23,10 @@
 	-DCMAKE_BUILD_TYPE:STRING="Debug" \
 	-DCMAKE_SKIP_RPATH=true \
 	-DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
+	-DPYTHON_SUFFIX=-python$*-dbg \
 	-DCMAKE_USE_PYTHON_VERSION="$*-dbg;$*_d;$*" \
-	-DPython_ADDITIONAL_VERSIONS="$*-dbg;$*_d;$*"
+	-DPython_ADDITIONAL_VERSIONS="$*-dbg;$*_d;$*" \
+	-DPYTHON_EXECUTABLE=/usr/bin/python$*-dbg
 
 override_dh_auto_configure-%:
 	mkdir -p build-$*
@@ -32,9 +34,11 @@
 	-DCMAKE_BUILD_TYPE:STRING="Release" \
 	-DCMAKE_SKIP_RPATH=true \
 	-DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
+	-DPYTHON_SUFFIX=-python$* \
 	-DCMAKE_USE_PYTHON_VERSION=$* \
 	-DPython_ADDITIONAL_VERSIONS=$* \
-	-DDEFAULT_PYTHON_BASENAME=python${DEFAULT_PY}
+	-DPYTHON_EXECUTABLE=/usr/bin/python$* \
+	-DDEFAULT_PYTHON_SUFFIX=-python${DEFAULT_PY}
 
 #### BUILD ####
 
@@ -95,6 +99,9 @@
 	# Setup the default version symbolic links
 	ln -sf libshiboken-python${DEFAULT_PY}.so \
 	               debian/libshiboken-dev/usr/lib/$(DEB_HOST_MULTIARCH)/libshiboken.so
+	# Make sure the pkg-config is the default's
+	install -D -m 644 build-${DEFAULT_PY}/data/shiboken.pc \
+			debian/libshiboken-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/shiboken.pc
 endif
 ifneq (,$(filter shiboken-dbg, $(shell dh_listpackages)))
 	ln -sf libshiboken-python${DEFAULT_PY}-dbg.so \
